//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.312
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using Microsoft.Ccr.Core;
using Microsoft.Dss.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using Microsoft.Dss.Services.SubscriptionManager;
using System;
using System.Collections.Generic;

using boe = Microsoft.Robotics.Services.BasicStamp2.Proxy;
using dssphttp = Microsoft.Dss.Core.DsspHttp;
using drive = Microsoft.Robotics.Services.Drive.Proxy;
using motor = Microsoft.Robotics.Services.Motor.Proxy;
using model = Microsoft.Robotics.PhysicalModel.Proxy;
using W3C.Soap;
using System.ComponentModel;

namespace Robotics.BsDrive
{
    
    /// <summary>
    /// BsDrive Service
    /// </summary>
    [Contract(Contract.Identifier)]
    [AlternateContract("http://schemas.microsoft.com/robotics/2006/05/drive.html")]
    [DisplayName("Boe-Bot Generic Drive")]
    [Description("Provides access to the Parallax BASIC Stamp 2 Boe-Bot drive service.\n(Uses the Generic Differential Drive contract.)\n(Partner with 'Boe-Bot BASIC Stamp 2').")]
    public class DriveService : DsspServiceBase
    {
        /// <summary>
        /// Microsoft.Robotics.Services.Drive.BsDrive Partner
        /// </summary>
        [Partner("SubMgr", Contract="http://schemas.microsoft.com/xw/2005/01/subscriptionmanager.html", CreationPolicy=PartnerCreationPolicy.CreateAlways, Optional=false)]
        private SubscriptionManagerPort _subMgrPort = new Microsoft.Dss.Services.SubscriptionManager.SubscriptionManagerPort();
        /// <summary>
        /// _main Port
        /// </summary>
        [ServicePort("/bsdrive", AllowMultipleInstances=false)]
        private drive.DriveOperations _mainPort = new Microsoft.Robotics.Services.Drive.Proxy.DriveOperations();
        /// <summary>
        /// Robotics.BsDrive.BsdriveService State
        /// </summary>
        [InitialStatePartner(Optional=true, ServiceUri="Robotics.BsDrive.BsdriveService.Config.xml")]
        private drive.DriveDifferentialTwoWheelState _state = new Microsoft.Robotics.Services.Drive.Proxy.DriveDifferentialTwoWheelState();

        /// <summary>
        /// Partner with the BasicStamp2 service
        /// </summary>
        [Partner("BASICStamp2", Contract = boe.Contract.Identifier, CreationPolicy = PartnerCreationPolicy.UseExistingOrCreate, Optional = false)]
        private boe.BasicStamp2Operations _boebotPort = new boe.BasicStamp2Operations();

        
        /// <summary>
        /// Default Service Constructor
        /// </summary>
        public DriveService(DsspServiceCreationPort creationPort) : 
                base(creationPort)
        {
        }
        /// <summary>
        /// Service Start
        /// </summary>
        protected override void Start()
        {
            InitializeState();

			base.Start();
        }

        #region Initialization 

        /// <summary>
        /// Initialize the drive state
        /// </summary>
        private void InitializeState()
        {
            if (_state == null)
            {
                _state = new drive.DriveDifferentialTwoWheelState();
            }

            if (_state.DistanceBetweenWheels == 0.0)
                _state.DistanceBetweenWheels = 0.105;

            _state.DriveState = drive.DriveState.Stopped;
            _state.IsEnabled = false;

            if (_state.LeftWheel == null)
                _state.LeftWheel = new motor.WheeledMotorState();
            if (_state.RightWheel == null)
                _state.RightWheel = new motor.WheeledMotorState();

            _state.LeftWheel.WheelSpeed = 0.0;
            _state.RightWheel.WheelSpeed = 0.0;

            if (_state.LeftWheel.GearRatio == 0.0)
                _state.LeftWheel.GearRatio = 1.0;
            if (_state.RightWheel.GearRatio == 0.0)
                _state.RightWheel.GearRatio = 1.0;

            if (_state.LeftWheel.Radius == 0.0)
                _state.LeftWheel.Radius = 0.033;
            if (_state.RightWheel.Radius == 0.0)
                _state.RightWheel.Radius = 0.033;

            if (_state.LeftWheel.MotorState == null)
                _state.LeftWheel.MotorState = new motor.MotorState("Left Wheel", 3, 1.0, false, new model.Pose());
            if (_state.LeftWheel.MotorState.HardwareIdentifier == 0)
                _state.LeftWheel.MotorState.HardwareIdentifier = 3;
            if (string.IsNullOrEmpty(_state.LeftWheel.MotorState.Name))
                _state.LeftWheel.MotorState.Name = "Left Wheel";
            if (_state.LeftWheel.MotorState.PowerScalingFactor == 0.0)
                _state.LeftWheel.MotorState.PowerScalingFactor = 1.0;

            if (_state.RightWheel.MotorState == null)
                _state.RightWheel.MotorState = new motor.MotorState("Right Wheel", 1, 1.0, true, new model.Pose());
            if (_state.RightWheel.MotorState.HardwareIdentifier == 0)
                _state.RightWheel.MotorState.HardwareIdentifier = 1;
            if (string.IsNullOrEmpty(_state.RightWheel.MotorState.Name))
                _state.RightWheel.MotorState.Name = "Right Wheel";
            if (_state.RightWheel.MotorState.PowerScalingFactor == 0.0)
                _state.RightWheel.MotorState.PowerScalingFactor = 1.0;

            SaveState(_state);
        }

        #endregion

        #region Operation Handlers

        /// <summary>
        /// HttpGet Handler
        /// </summary>
        /// <param name="get"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Concurrent)]
        public virtual IEnumerator<ITask> HttpGetHandler(Microsoft.Dss.Core.DsspHttp.HttpGet get)
        {
            get.ResponsePort.Post(new dssphttp.HttpResponseType(_state));
            yield break;
        }
        /// <summary>
        /// HttpPost Handler
        /// </summary>
        /// <param name="submit"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Concurrent)]
        public virtual IEnumerator<ITask> HttpPostHandler(dssphttp.HttpPost submit)
        {
            // TODO: Implement Submit operations here.
            throw new NotImplementedException("TODO: Implement Submit operations here.");
        }
        /// <summary>
        /// ReliableSubscribe Handler
        /// </summary>
        /// <param name="subscribe"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> ReliableSubscribeHandler(drive.ReliableSubscribe subscribe)
        {
            base.SubscribeHelper(_subMgrPort, subscribe.Body, subscribe.ResponsePort);
            yield break;
        }
        /// <summary>
        /// Subscribe Handler
        /// </summary>
        /// <param name="subscribe"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> SubscribeHandler(drive.Subscribe subscribe)
        {
            base.SubscribeHelper(_subMgrPort, subscribe.Body, subscribe.ResponsePort);
            yield break;
        }
        /// <summary>
        /// Get Handler
        /// </summary>
        /// <param name="get"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Concurrent)]
        public virtual IEnumerator<ITask> GetHandler(drive.Get get)
        {
            get.ResponsePort.Post(_state);
            yield break;
        }
        /// <summary>
        /// Update Handler
        /// </summary>
        /// <param name="update"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> UpdateHandler(drive.Update update)
        {
            // TODO: Implement Update operations here.
            throw new NotImplementedException("TODO: Implement Update operations here.");
        }

        /// <summary>
        /// EnableDrive Handler
        /// </summary>
        /// <param name="update"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual void EnableDriveHandler(drive.EnableDrive update)
        {
            _state.IsEnabled = update.Body.Enable;
            _state.TimeStamp = DateTime.Now;
            update.ResponsePort.Post(DefaultUpdateResponseType.Instance);
        }

        /// <summary>
        /// SetDrivePower Handler
        /// </summary>
        /// <param name="update"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> SetDrivePowerHandler(drive.SetDrivePower update)
        {
            if (!_state.IsEnabled)
            {
                update.ResponsePort.Post(Fault.FromException(new InvalidOperationException("The Boe-Bot drive is not enabled.")));
                yield break;
            }

            yield return Arbiter.Choice(_boebotPort.UpdateMotorSpeed(update.Body.LeftWheelPower, update.Body.RightWheelPower),
                delegate(DefaultUpdateResponseType ok) 
                {
                    update.ResponsePort.Post(ok);
                },
                delegate(Fault fault) 
                {
                    update.ResponsePort.Post(fault);
                });
                
        }

        /// <summary>
        /// SetDriveSpeed Handler
        /// </summary>
        /// <param name="update"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> SetDriveSpeedHandler(drive.SetDriveSpeed update)
        {
            if (!_state.IsEnabled)
            {
                update.ResponsePort.Post(Fault.FromException(new InvalidOperationException("The Boe-Bot drive is not enabled.")));
                yield break;
            }

            // TODO: Convert meters/second to BoeBot power based on radius of wheels.
            double leftPower = update.Body.LeftWheelSpeed;
            double rightPower = update.Body.RightWheelSpeed;

            yield return Arbiter.Choice(_boebotPort.UpdateMotorSpeed(leftPower, rightPower),
                delegate(DefaultUpdateResponseType ok)
                {
                    update.ResponsePort.Post(ok);
                },
                delegate(Fault fault)
                {
                    update.ResponsePort.Post(fault);
                });
        }

        /// <summary>
        /// RotateDegrees Handler
        /// </summary>
        /// <param name="update"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> RotateDegreesHandler(drive.RotateDegrees update)
        {
            // You can implement a rotation command based on time and current speed.
            throw new NotImplementedException("RotateDegrees is not implemented on Boe-Bot.");
        }

        /// <summary>
        /// DriveDistance Handler
        /// </summary>
        /// <param name="update"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> DriveDistanceHandler(drive.DriveDistance update)
        {
            // You can implement a drive distance command based on time and current speed.
            throw new NotImplementedException("DriveDistance is not implemented on Boe-Bot.");
        }

        /// <summary>
        /// AllStop Handler
        /// </summary>
        /// <param name="update"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Exclusive)]
        public virtual IEnumerator<ITask> AllStopHandler(drive.AllStop update)
        {
            yield return Arbiter.Choice(_boebotPort.UpdateMotorSpeed(0.0, 0.0),
                delegate(DefaultUpdateResponseType ok)
                {
                    update.ResponsePort.Post(ok);
                },
                delegate(Fault fault)
                {
                    update.ResponsePort.Post(fault);
                });
        }
        #endregion
    }

    /// <summary>
    /// BsDrive Contract
    /// </summary>
    public sealed class Contract
    {
        /// The Unique Contract Identifier for the BsDrive service
        public const String Identifier = "http://schemas.tempuri.org/2007/06/bsdrive.html";
    }
}
